#include <Windows.h>
#include <Shlwapi.h>
#include <algorithm>
#include <vector>
#include "Util.h"
#include "Playlist.h"

CPlaylist::CPlaylist()
    : m_pos(0)
{
}

// vCXgt@C܂TSt@CĐXgɉ
// : ꂽʒu, s: 
int CPlaylist::PushBackListOrFile(LPCTSTR path, bool fMovePos)
{
    // Jg̐΃pXɕϊ
    TCHAR fullPath[MAX_PATH];
    DWORD rv = ::GetFullPathName(path, _countof(fullPath), fullPath, NULL);
    if (rv == 0 || rv >= MAX_PATH) return -1;

    int pos = -1;
    LPCTSTR ext = ::PathFindExtension(fullPath);
    if (ext && (!::lstrcmpi(ext, TEXT(".m3u")) || !::lstrcmpi(ext, TEXT(".tslist")))) {
        // vCXgt@CƂď
        pos = PushBackList(fullPath);
    }
    else {
        // TSt@CƂď
        PLAY_INFO pi;
        ::lstrcpyn(pi.path, fullPath, _countof(pi.path));
        pos = static_cast<int>(size());
        push_back(pi);
    }
    if (fMovePos && pos >= 0) m_pos = pos;
    return pos;
}

// vCXgt@CĐXgɉ
int CPlaylist::PushBackList(LPCTSTR fullPath)
{
    int pos = -1;
    TCHAR *pRet = NewReadUtfFileToEnd(fullPath, FILE_SHARE_READ);
    if (pRet) {
        // ΃pXƂ̌p
        TCHAR dirName[MAX_PATH];
        ::lstrcpyn(dirName, fullPath, _countof(dirName));
        ::PathRemoveFileSpec(dirName);

        for (TCHAR *p = pRet; *p;) {
            // 1s擾pi߂
            TCHAR line[512];
            int len = ::StrCSpn(p, TEXT("\r\n"));
            ::lstrcpyn(line, p, min(len+1, _countof(line)));
            p += len;
            if (*p == TEXT('\r') && *(p+1) == TEXT('\n')) ++p;
            if (*p) ++p;

            // E̋󔒕菜
            ::StrTrim(line, TEXT(" \t"));
            if (line[0] != TEXT('#')) {
                // E"̑ΉΎ菜
                if (line[0] == TEXT('"') && line[::lstrlen(line)-1] == TEXT('"')) ::StrTrim(line, TEXT("\""));
                // XbVobNXbV
                for (TCHAR *q=line; *q; ++q) if (*q==TEXT('/')) *q=TEXT('\\');
                if (line[0]) {
                    PLAY_INFO pi;
                    if (::PathIsRelative(line)) {
                        // ΃pX
                        if (!::PathCombine(pi.path, dirName, line)) pi.path[0] = 0;
                    }
                    else {
                        // ΃pX
                        ::lstrcpyn(pi.path, line, _countof(pi.path));
                    }
                    if (::PathFileExists(pi.path)) {
                        if (pos < 0) pos = static_cast<int>(size());
                        push_back(pi);
                    }
                }
            }
        }
        delete [] pRet;
    }
    return pos;
}

// ݈ʒuPLAY_INFOOɈړ
bool CPlaylist::MoveCurrentToPrev()
{
    if (m_pos != 0 && m_pos < size()) {
        std::swap((*this)[m_pos], (*this)[m_pos-1]);
        --m_pos;
        return true;
    }
    return false;
}

// ݈ʒuPLAY_INFOɈړ
bool CPlaylist::MoveCurrentToNext()
{
    if (m_pos+1 < size()) {
        std::swap((*this)[m_pos], (*this)[m_pos+1]);
        ++m_pos;
        return true;
    }
    return false;
}

static inline bool CompareAsc(const PLAY_INFO& l, const PLAY_INFO& r) { return ::lstrcmpi(l.path, r.path) < 0; }

static inline bool CompareDesc(const PLAY_INFO& l, const PLAY_INFO& r) { return ::lstrcmpi(l.path, r.path) > 0; }

// \[g
bool CPlaylist::Sort(bool fDesc)
{
    size_t sz = size();
    if (m_pos < sz) {
        for (size_t i = 0; i < sz; ++i) {
            (*this)[i].fWork = m_pos == i;
        }
        std::sort(begin(), end(), fDesc ? CompareDesc : CompareAsc);
        for (size_t i = 0; i < sz; ++i) {
            if ((*this)[i].fWork) {
                m_pos = i;
                break;
            }
        }
        return true;
    }
    return false;
}

// ݈ʒuPLAY_INFO폜
bool CPlaylist::EraseCurrent()
{
    if (m_pos < size()) {
        erase(begin() + m_pos);
        // ݈ʒu͂܂PLAY_INFOɈڂAȂΑOPLAY_INFOɈڂ
        if (m_pos != 0 && m_pos >= size()) --m_pos;
        return true;
    }
    return false;
}

// ݈ʒuPLAY_INFOȊO폜
bool CPlaylist::ClearWithoutCurrent()
{
    if (m_pos < size()) {
        PLAY_INFO pi = (*this)[m_pos];
        clear();
        push_back(pi);
        m_pos = 0;
        return true;
    }
    return false;
}

// ݈ʒuOɈړ
// ړłȂfalseԂ
bool CPlaylist::Prev(bool fLoop)
{
    if (fLoop && !empty() && m_pos == 0) {
        m_pos = size() - 1;
        return true;
    }
    else if (m_pos != 0) {
        --m_pos;
        return true;
    }
    return false;
}

// ݈ʒuɈړ
// ړłȂfalseԂ
bool CPlaylist::Next(bool fLoop)
{
    if (fLoop && !empty() && m_pos+1 >= size()) {
        m_pos = 0;
        return true;
    }
    else if (m_pos+1 < size()) {
        ++m_pos;
        return true;
    }
    return false;
}

// Ƃďo͂
int CPlaylist::ToString(TCHAR *pStr, int max, bool fFileNameOnly) const
{
    if (!pStr) {
        // o͂ɕKvȗvfZo
        int strSize = 1;
        for (const_iterator it = begin(); it != end(); ++it) {
            LPCTSTR path = fFileNameOnly ? ::PathFindFileName((*it).path) : (*it).path;
            strSize += ::lstrlen(path) + 2;
        }
        return strSize;
    }
    if (max >= 1) {
        // o
        int strPos = 0;
        pStr[0] = 0;
        for (const_iterator it = begin(); max-strPos-2 > 0 && it != end(); ++it) {
            LPCTSTR path = fFileNameOnly ? ::PathFindFileName((*it).path) : (*it).path;
            ::lstrcpyn(pStr + strPos, path, max-strPos-2);
            ::lstrcat(pStr + strPos, TEXT("\r\n"));
            strPos += ::lstrlen(pStr + strPos);
        }
        return strPos + 1;
    }
    return 0;
}
